//+------------------------------------------------------------------+
//|                                                    CopyParam.mq5 |
//|                             Copyright 2010, Loong@forum.mql4.com |
//|                             http://login.mql5.com/en/users/Loong |
//+------------------------------------------------------------------+
#property copyright "2010, Loong@forum.mql4.com"
#property link      "http://login.mql5.com/en/users/Loong"
#property version   "1.00"
#property indicator_separate_window

struct SLoongIndiParam           // Indicator parameter
  {
   ENUM_INDICATOR eIndiType;     // enum of Indicator Type
   int            iIndiType;     // value of Indicator Type, only used to look and check
   int            iNumParams;    // number of the parameter
   MqlParam       aIndiParam[8]; // parameter of Indicator
  };
const SLoongIndiParam caIndiParam[]={
   {IND_ALLIGATOR,   7,  8, { { TYPE_INT,13, 0.0, "0"},
                              { TYPE_INT, 8, 0.0, "1"},
                              { TYPE_INT, 8, 0.0, "2"},
                              { TYPE_INT, 5, 0.0, "3"},
                              { TYPE_INT, 5, 0.0, "4"},
                              { TYPE_INT, 3, 0.0, "5"},
                              { TYPE_INT, MODE_SMMA, 0.0, "6"},
                              { TYPE_INT, PRICE_MEDIAN, 0.0, "7"} } }
};
const MqlParam cIndiParamALLIGATOR[8] = { { TYPE_INT,13, 0.0, ""}, 
                                          { TYPE_INT, 8, 0.0, ""},
                                          { TYPE_INT, 8, 0.0, ""}, 
                                          { TYPE_INT, 5, 0.0, ""},
                                          { TYPE_INT, 5, 0.0, ""}, 
                                          { TYPE_INT, 3, 0.0, ""},
                                          { TYPE_INT, MODE_SMMA, 0.0, ""}, 
                                          { TYPE_INT, PRICE_MEDIAN, 0.0, ""} };
MqlParam m_IndiParam[8];

struct testStruct
  {
   //ENUM_DATATYPE     type;                    // type of the input parameter, value of ENUM_DATATYPE
   //long              integer_value;           // field to store an integer type
   //double            double_value;            // field to store a double type
   string            string_value;            // field to store a string type
  };
struct SLoongTestStruct          // Indicator parameter
  {
   ENUM_INDICATOR eIndiType;     // enum of Indicator Type
   int            iIndiType;     // value of Indicator Type, only used to look and check
   int            iNumParams;    // number of the parameter
   testStruct     aIndiParam[8]; // parameter of Indicator
  };
const SLoongTestStruct caTestStruct[]={
   {IND_ALLIGATOR,   7,  8, { { "0" },
                              { "1" },
                              { "2" },
                              { "3" },
                              { "4" },
                              { "5" },
                              { "6" },
                              { "7" } } }
};
/*
const SLoongTestStruct caTestStruct[]={
   {IND_ALLIGATOR,   7,  8, { { TYPE_INT,13, 0.0, ""},
                              { TYPE_INT, 8, 0.0, ""},
                              { TYPE_INT, 8, 0.0, ""},
                              { TYPE_INT, 5, 0.0, ""},
                              { TYPE_INT, 5, 0.0, ""},
                              { TYPE_INT, 3, 0.0, ""},
                              { TYPE_INT, MODE_SMMA, 0.0, ""},
                              { TYPE_INT, PRICE_MEDIAN, 0.0, ""} } }
};
*/

bool VisitMqlParam(const int iNum, const MqlParam& rcaParam[])
{
  Print("VisitMqlParam");
   if (iNum<=0)
      return(true);
  Print("VisitMqlParam{before for}, iNum="+iNum);
   for(int i=0;i<iNum;i++)
   {
/*
  Print("VisitMqlParam{for}, i="+i);
  Print("VisitMqlParam{for}, rcaParam[i].type="+rcaParam[i].type);
  Print("VisitMqlParam{for}, rcaParam[i].integer_value="+rcaParam[i].integer_value);
  Print("VisitMqlParam{for}, rcaParam[i].double_value="+rcaParam[i].double_value);
  Print("VisitMqlParam{for}, rcaParam[i].string_value="+rcaParam[i].string_value);
*/
      m_IndiParam[i].type          = rcaParam[i].type;
      m_IndiParam[i].integer_value = rcaParam[i].integer_value;
      m_IndiParam[i].double_value  = rcaParam[i].double_value;
      m_IndiParam[i].string_value  = rcaParam[i].string_value;
/*
  Print("VisitMqlParam{for}, m_IndiParam[i].type="+m_IndiParam[i].type);
  Print("VisitMqlParam{for}, m_IndiParam[i].integer_value="+m_IndiParam[i].integer_value);
  Print("VisitMqlParam{for}, m_IndiParam[i].double_value="+m_IndiParam[i].double_value);
  Print("VisitMqlParam{for}, m_IndiParam[i].string_value="+m_IndiParam[i].string_value);
*/
   }
  Print("VisitMqlParam{before return}");
   return(true);
}

bool VisitIndiParam(const SLoongIndiParam& rcaIndiParam)
{
  Print("VisitIndiParam");
      int iNum;
      iNum = rcaIndiParam.iNumParams;
      if (iNum<=0)
         return(true);
  Print("VisitIndiParam{before for}, iNum="+iNum);
      for(int i=0;i<iNum;i++)
      {
  Print("VisitIndiParam{for}, i="+i);
  Print("VisitIndiParam{for}, rcaIndiParam.aIndiParam[i].type="+rcaIndiParam.aIndiParam[i].type);
  Print("VisitIndiParam{for}, rcaIndiParam.aIndiParam[i].integer_value="+rcaIndiParam.aIndiParam[i].integer_value);
  Print("VisitIndiParam{for}, rcaIndiParam.aIndiParam[i].double_value="+rcaIndiParam.aIndiParam[i].double_value);
  Print("VisitIndiParam{for}, rcaIndiParam.aIndiParam[i].string_value="+rcaIndiParam.aIndiParam[i].string_value);
      }
  Print("VisitIndiParam{before return}");
      return(true);
}

bool VisitTestStruct(const SLoongTestStruct& rcaTestStruct)
{
  Print("VisitTestStruct");
      int iNum;
      iNum = rcaTestStruct.iNumParams;
      if (iNum<=0)
         return(true);
  Print("VisitTestStruct{before for}, iNum="+iNum);
      for(int i=0;i<iNum;i++)
      {
  Print("VisitTestStruct{for}, i="+i);
  //Print("VisitTestStruct{for}, rcaTestStruct.aIndiParam[i].type="+rcaTestStruct.aIndiParam[i].type);
  //Print("VisitTestStruct{for}, rcaTestStruct.aIndiParam[i].integer_value="+rcaTestStruct.aIndiParam[i].integer_value);
  //Print("VisitTestStruct{for}, rcaTestStruct.aIndiParam[i].double_value="+rcaTestStruct.aIndiParam[i].double_value);
  Print("VisitTestStruct{for}, rcaTestStruct.aIndiParam[i].string_value="+rcaTestStruct.aIndiParam[i].string_value);
      }
  Print("VisitTestStruct{before return}");
      return(true);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   VisitMqlParam(8, cIndiParamALLIGATOR);
   VisitIndiParam(caIndiParam[0]);
   //VisitTestStruct(caTestStruct[0]);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
//---
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
